library mapped;

uses
   Windows,Messages, SysUtils, Dialogs;

const
  WM_DATA = WM_USER + 1024;

var
  hMapping: THandle;

{$R *.RES}

(*
YإmapfileNإ, Yvإ
Ǧ^vإߪhanele
MaxMapLen                 -> mapedfile jp
TheMappingConstant   ->  mapfile qDW
*)
function ObtainMappingHandle( MapName:string ): THandle;
begin
  Result := CreateFileMapping($FFFFFFFF,
                                    nil,               // lpFileMappingAttributes
                         PAGE_READWRITE,               // flProtect
                                      0,
                                      1,               // Size Of Map File
                                      pchar(MapName)); // lpName
  if Result <> 0 then                                  // Did it return a valid handle?
    if GetLastError = ERROR_ALREADY_EXISTS then        // Did it already exist?
      begin
        CloseHandle(Result);                           // Close this one - we will open existing one instead
        Result := OpenFileMapping(FILE_MAP_WRITE,False,pchar(MapName) );
      end;
end;

procedure OpenMap( MapName:string );
begin
   {Ыؤ@ӤMgֹH}
  HMapping := ObtainMappingHandle( MapName );
  if (hMapping = 0) then
  begin
    ShowMessage('ЫذOMg');
    exit;
  end;
end;

procedure CloseMap;
begin
  if HMapping <> 0 then
    CloseHandle(HMapping);
end;


procedure WriteMap(text:string);
Var
  ThePtr : PChar; (* Mapped File start address *)
  str: pchar;
begin
  str := pchar(text);
  // gJmapping file
  ThePtr := MapViewOfFile( HMapping,FILE_MAP_WRITE,0,0,0 );(*\ǥX_l}*)
  StrPLCopy( ThePtr, str, Length(str) );(*gJ}*)
  UnmapViewOfFile( ThePtr );
end;

function ReadMap(MapName:string):pchar;
var
  MapHandle : THandle;
  ThePtr : Pchar;
  S: array[0..254] of Char;
begin
  MapHandle := OpenFileMapping(FILE_MAP_WRITE, (*XݬMg*)
    False, (*i~Ӫ*)
    pchar(MapName)); (*MgɮצWr*)
  if MapHandle = 0 then
  begin
    ShowMessage('wOMg!');
    Halt;
  end;
  (*oOMg*)
  ThePtr := MapViewOfFile(MapHandle,FILE_MAP_WRITE,0,0,0);
  if ThePtr = nil then
  begin
    CloseHandle(MapHandle);
    ShowMessage('Lk˵OMg');
    halt;
  end;
  FillChar(s, SizeOf(ThePtr), 0);
  strcopy(s, ThePtr);
  result := s;
  UnmapViewOfFile(ThePtr);
end;

exports
  OpenMap,
  CloseMap,
  ReadMap,
  WriteMap;

begin
end.
